#include "field.h"
#include "surface.h"
#include "interval_exchange.h"
#include "other.h"
#include <iostream>
#include <cln/real_io.h>
using namespace std;


int main(){
  //FieldElement direction(1,0,0,0);
  //FieldElement direction(5,6,0,-2);
  //FieldElement direction(5,18,0,-7);
  //FieldElement direction(170,196,0,-65);


  //FieldElement direction(1,1,0,0);
  //FieldElement direction(2,3,0,-1);
  //FieldElement direction(3,3,0,-1);
  //FieldElement direction(4,5,0,-2);
  FieldElement direction(6,5,0,-2);
  //FieldElement direction(67,79,0,-33);
  //FieldElement direction(7,16,0,-7);
  //FieldElement direction(21,24,0,-10);


  //FieldElement direction(52,61,3,-28);

  //FieldElement direction(5,6,0,-1);

  FieldElement orthogonal=direction*FieldElement(1,3);
  
  // The first step is to compute the interval exchange transformation.

  // we compute the lengths of the intervals on the left
  FieldElement left_widths[8];
  for (int i=0; i<8; i++){
    left_widths[i]=(leftside[i+1]-leftside[i]).vectorProjection(orthogonal);
    cout << "length of interval " << i << " is " << left_widths[i] << endl;
  }

  IntervalExchange ie(8,left_widths,permutation,holonomy); 

  ie.iteritively_split();

  ie.color_code();

  writePostscript("annulus.ps", ie, orthogonal);

  printSaddleLengths(ie,orthogonal);

  //cl_R l=saddleLength(5,ie,orthogonal);
  //cout << "length= " << l << endl;
}
